{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 2006-2007 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: servers.pas,v 1.1.2.7 2007/01/23 14:15:56 mw Exp $ }

{$I XPDEFINE.INC }
{$O+,F+}
unit servers;

interface

procedure renew_Servers;

implementation

uses xp0,fileio,typeform,md5;

procedure renew_Servers;

var f,g:text;           
    t:string;

const servers:string='SERVERS.DAT';

{Alte Versionen der SERVERS.DAT in Includedatei eintragen}

{$I SERVERS.INC} 

    function outdated(f:string):boolean;

    var i:integer;
        StrDigest: string[32];

    begin
      {MD5-Summe der SERVERS.DAT berechnen}
      StrDigest:=md5sum_file(servers);
      {MD5-Summe gegen alle alten SERVERS.DAT vergleichen}
      outdated:=false;
      for i:=1 to oldfile do
      if UStr(oldfiles[i])=StrDigest then
      begin
        outdated:=true;
        break;
      end;
    end;

begin
  assign(f,servers);

  {Existiert die SERVERS.DAT nicht oder ist sie veraltet?       }
  {Unbekannte (=Uservernderte) SERVERS.DAT gelten automatisch  }
  {als aktuell                                                  }
  if (not existf(f)) or (outdated(servers)) then begin
    case ParLanguage[1] of
      'E' : assign(g,'SAMPLES\'+servers);   {Englische SERVERS.DAT}
      'D' : assign(g,'BEISPIEL\'+servers);  {Deutsche SERVERS.DAT}
    else
      assign(g,'SAMPLES\'+servers);         {Rckfallebene ist die englische SERVERS.DAT} 
    end;
    if not existf(g) then assign(g,'BEISPIEL\'+servers);  {Benutze wenn keine }
                                            {sprachspezifische Datei vorhanden die deutsche }
                                            {SERVERS.DAT}
    if existf(g) then begin                 {Teste auf Existenz der Distributions-SERVERS.DAT}
      reset(g);
      rewrite(f);
      while not eof(g) do begin             {berschreibe die SERVERS.DAT im XP-Verzeichnis}
        readln(g,t);    
        writeln(f,t);
      end;
      close(f);
      close(g);
    end;
  end;
end;

begin
end.
{
  $Log: servers.pas,v $
  Revision 1.1.2.7  2007/01/23 14:15:56  mw
  MW: - Neues Jahr 2007

  Revision 1.1.2.6  2006/03/31 09:03:30  mw
  MW: - Anpassung an md5.pas 3.09fxp3

  Revision 1.1.2.5  2006/03/30 07:29:15  mw
  MW: - Vereinfachung der SERVERS-Unit durch Benutzung von md5.md5sum()
        und damit Weglassen allen doppelt aufgefhrten Codes.

  Revision 1.1.2.3  2006/02/25 18:22:42  mw
  MW: - Bugfixing von Servers.dat : Es wurde eine leere Servers.dat erzeugt,
        wenn keine Servers.dat existierte.

  Revision 1.1.2.1  2006/02/25 16:03:02  mw
  MW: - Die Liste der Mail- und News-Server SERVERS.DAT wird jetzt
        automatisch aktualisiert, sofern der Benutzer die Datei nicht
        modifiziert hat. Dabei wird soweit mglich auch die Sprach-
        einstellung bercksichtig.

}
