{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 2004-2007      Martin Wodrich, http://www.martinwodrich.de  }
{                               software@martinwodrich.de         }
{                                                                 }
{ Dieser Quelltext ist Freeware.                                  }
{                                                                 }
{ Die allgemeinen Nutzungsbedingungen fuer diesen Quelltext       }
{ finden Sie in der Datei TOUCH.TXT oder auf                      }
{ http://www.martinwodrich.de/Software/Touch/nutzung.htm          }
{ --------------------------------------------------------------- }
{ $Id: touch1.pas,v 1.1.2.2 2007-07-28 19:31:37 mw Exp $ }
{ Betriebsystemabhngige Routinen }
unit touch1;

interface
{$I TOUCH.INC }

uses touch0,{$IFDEF Windows}windos{$ELSE}{$IFDEF unix}dos,oldlinux{$ELSE}dos{$ENDIF}{$ENDIF};

{$IFDEF unix}
function ftime2epoch(ftime:longint):longint;
function unixsetftime(path:pathstr; etime:longint):boolean;
{$ENDIF}

implementation

{$IFDEF unix}
function ftime2epoch(ftime:longint):longint;
var dt: DateTime;
begin
  UnPackTime(ftime,dt);
  ftime2epoch:=LocalToEpoch(dt.Year,dt.Month,dt.Day,dt.Hour,dt.Min,dt.Sec);
end;

function unixsetftime(path:pathstr; etime:longint):boolean;
var utim:utimbuf;
begin
  utim.actime:=etime;
  utim.modtime:=etime;
  unixsetftime:=Utime(path,utim);
end;
{$ENDIF}

end.
{
  $Log: touch1.pas,v $
  Revision 1.1.2.2  2007-07-28 19:31:37  mw
  MW: - Update auf TOUCH 1.4.0

  Revision 1.1.2.1  2006/09/24 09:20:53  mw
  MW: - Update auf Touch 1.3.1

}



